# Copyright (c) 2016 3D Control Systems LTD

# Author: Vladimir Avdeev <another.vic@yandex.ru>

from dual_cam import Camera

class MultiCamera(Camera):

    def search_cameras(self):
        self.indexes = []
        Camera.search_cameras(self)

    def init_capture(self, capture):
        Camera.init_capture(self, capture)
        index = self.captures.index(capture)
        self.indexes.append(index)
        capture.release()

    def make_shot(self, capture):
        index = self.indexes[self.captures.index(capture)]
        del(capture)
        try:
            capture = self.cv2.VideoCapture(index)
        except Exception as e:
            self.logger.warning("Error while opening video capture: " + str(e))
            self.fails[index] += 1
        else:
            if capture.isOpened():
                self.captures[index] = capture
                frame = Camera.make_shot(self, capture)
                capture.release()
                return frame


if __name__ == "__main__":
    MultiCamera()